/* tailor.h -- Not copyrighted 1993 Mark Adler */

#if defined(VM_CMS) || defined(MVS)
#  include "vmcms/vmzip.h"
#endif

#ifdef __arm
#  define RISCOS
#endif /* __arm */

/* Define MSDOS for Turbo C and Power C */
#ifdef __POWERC
#  define __TURBOC__
#  define MSDOS
#endif /* __POWERC */

#if (defined(__MSDOS__) && !defined(MSDOS))
#  define MSDOS
#endif

#ifdef ATARI_ST
#  undef MSDOS   /* avoid the MS-DOS specific includes */
#endif

#if defined(_MSC_VER) && !defined(MSC)
#  define MSC                /* for old versions, MSC must be set explicitly */
#endif

/* Use prototypes and ANSI libraries if _STDC__, or Microsoft or Borland C,
 * or Silicon Graphics, or IBM C Set/2, or Watcom C, or GNU gcc under emx.
 */
#if defined(__STDC__) || defined(MSDOS) || defined(ATARI_ST) || defined(sgi)
#  ifndef PROTO
#    define PROTO
#  endif /* !PROTO */
#  define MODERN
#endif

#if defined(__IBMC__) || defined(__EMX__) || defined(__WATCOMC__)
#  ifndef PROTO
#    define PROTO
#  endif /* !PROTO */
#  define MODERN
#endif

#if defined(__BORLANDC__) || (defined(__DECC) && defined(VMS))
#  ifndef PROTO
#    define PROTO
#  endif /* !PROTO */
#  define MODERN
#endif

#ifdef __IBMC__
#  define S_IFMT 0xF000
#endif /* __IBMC__ */

#if defined(__WATCOMC__) && defined(__386__)
#  define WATCOMC_386
#endif

#if defined(__EMX__) || defined(WATCOMC_386) || defined(__BORLANDC__)
#  if (defined(OS2) && !defined(__32BIT__))
#    define __32BIT__
#  endif
#endif

#if (defined(__OS2__) && !defined(OS2))
#  define OS2
#endif

/* For FreeBSD, NetBSD, 386BSD, 4.4BSD, BSDI, <sys/param.h> defines BSD4_4 */
#if (defined(unix) && !defined(NO_PARAM_H))
#  include <sys/param.h>
#endif

#ifdef __COMPILER_KCC__
#  define TOPS20
#  define NOPROTO
#  define NO_SYMLINK
#  define NO_TERMIO
#  define DIRENT
#  define BIG_MEM
  extern int isatty();
# define window_size winsiz
#endif

/* Turn off prototypes if requested */
#if (defined(NOPROTO) && defined(PROTO))
#  undef PROTO
#endif

/* Used to remove arguments in function prototypes for non-ANSI C */
#ifdef PROTO
#  define OF(a) a
#else /* !PROTO */
#  define OF(a) ()
#endif /* ?PROTO */

/* Avoid using const if compiler does not support it */
#ifndef MODERN  /* if this fails, try: ifndef__STDC__ */
#  define const
#endif

#ifdef MACOS
#  define DYN_ALLOC
#endif

#if defined(MSDOS) && !defined(OS2) && !defined(WIN32) && !defined(__32BIT__)
#  if !defined(__EMX__) && !defined(__GO32__) && !defined(WATCOMC_386)
#    define MSDOS16 /* 16 bit MSDOS only */
#  endif
#endif

#if defined(MSDOS16) || (defined(OS2) && !defined(__32BIT__))
#  define MEMORY16
#endif

#ifdef MEMORY16
#  ifdef NO_ASM
#    ifdef ASM_CRC
#      undef ASM_CRC
#    endif
#    ifdef ASMV
#      undef ASMV
#    endif
#  else /* !NO_ASM */
#    ifndef ASM_CRC
#      define ASM_CRC 1
#    endif
#    ifndef ASMV
#      define ASMV 1
#    endif
#  endif /* ?NO_ASM */
#  ifdef __TURBOC__
#    include <alloc.h>
#    define DYN_ALLOC
    /* Turbo C 2.0 does not accept static allocations of large arrays */
     void far * fcalloc OF((unsigned items, unsigned size));
     void fcfree (void far *ptr);
#  else /* !__TURBOC__ */
#    include <malloc.h>
#    define farmalloc _fmalloc
#    define farfree   _ffree
#    define fcalloc(nitems,itemsize) halloc((long)(nitems),(itemsize))
#    define fcfree(ptr) hfree((void huge *)(ptr))
#  endif /* ?__TURBOC__ */
#else /* !MEMORY16 */
#  if defined(WIN32)
#    include <malloc.h>
#  endif
#  ifdef __WATCOMC__
#    undef huge
#    undef far
#    undef near
#  endif
#  ifndef __IBMC__
#    define huge
#    define far
#    define near
#  endif
#  define farmalloc malloc
#  define farfree   free
#  define fcalloc(items,size) calloc((unsigned)(items), (unsigned)(size))
#  define fcfree    free
#  if (!defined(PROTO) && !defined(TOPS20))
     extern char *calloc(); /* essential for 16 bit systems (AT&T 6300) */
#  endif
#endif /* ?MSDOS */


#if (defined(OS2) && !defined(MSDOS))
/* MSDOS is defined anyway with MS C 16-bit. So the block above works.
 * For the 32-bit compilers, MSDOS must not be defined in the block above. */
#  define MSDOS
/* inherit MS-DOS file system etc. stuff */
#endif

#if (defined(WIN32) && !defined(MSDOS))
/* MSDOS is defined anyway with MS C 16-bit. So the block above works.
 * For the 32-bit compilers, MSDOS may not be defined.  But, Windows 95
 * (and Windows NT) file systems are (to some extend) extensions of MSDOS. */
#  define MSDOS
/* inherit MS-DOS file system etc. stuff */
#endif


/* Define MSVMS if MSDOS or VMS defined -- ATARI also does, Amiga could */
#if defined(MSDOS) || defined(VMS)
#  define MSVMS
#endif

/* case mapping functions. case_map is used to ignore case in comparisons,
 * to_up is used to force upper case even on Unix (for dosify option).
 */
#if defined(MSVMS) || defined(AMIGA)
#  define case_map(c) upper[(c) & 0xff]
#  define to_up(c)    upper[(c) & 0xff]
#else
#  define case_map(c) (c)
#  define to_up(c)    ((c) >= 'a' && (c) <= 'z' ? (c)-'a'+'A' : (c))
#endif

/* Define void, zvoid, and extent (size_t) */
#include <stdio.h>
#ifdef MODERN
#  if (!defined(M_XENIX) && !(defined(__GNUC__) && defined(sun)))
#    include <stddef.h>
#  endif /* !M_XENIX */
#  ifndef NO_STDLIB_H
#    include <stdlib.h>
#  endif
#  if defined(SYSV) || defined(BSD4_4) || defined(__GO32__) || \
      defined(_POSIX_SOURCE)
#    include <unistd.h> /* usually defines _POSIX_VERSION */
#  endif
   typedef size_t extent;
   typedef void zvoid;
#else /* !MODERN */
   typedef unsigned int extent;
#  define void int
   typedef char zvoid;
#endif /* ?MODERN */

/* Get types and stat */
#ifdef VMS
#  include <types.h>
#  include <stat.h>
#  include <unixio.h>
#  if defined(VMS_PK_EXTRA) && defined(VMS_IM_EXTRA)
#    undef VMS_IM_EXTRA                 /* PK style takes precedence */
#  endif
#  if !defined(VMS_PK_EXTRA) && !defined(VMS_IM_EXTRA)
#    define VMS_IM_EXTRA 1              /* IM style VMS support is default */
#  endif
#  define unlink delete
#  define NO_SYMLINK
#  define SSTAT vms_stat
#  define EXIT(exit_code) vms_exit(exit_code)
#  define RETURN(exit_code) {vms_exit(exit_code); return 1;}
   extern int  vms_stat OF((char *file, stat_t *s));
   extern void vms_exit OF((int e));
#endif /* VMS */

#ifdef MACOS
#  include <types.h>
#  include <stddef.h>
#  include <Files.h>
#  include <StandardFile.h>
#  include <Think.h>
#  include <LoMem.h>
#  include <Pascal.h>
#  include "mac/macstat.h"
#  define NO_SYMLINK
#endif

#ifdef ATARI_ST
#  include <ext.h>
#  include <tos.h>
#endif

#ifdef AMIGA
   int wild OF((char *));
   char *GetComment OF((char *));
   /* default to MEDIUM_MEM, but allow makefile override */
#  if ( (!defined(BIG_MEM)) && (!defined(SMALL_MEM)))
#    define MEDIUM_MEM
#  endif
#  if defined(LATTICE) || defined(__SASC)
#    include <sys/types.h>
#    include <sys/stat.h>
     extern int isatty(int);   /* SAS has no unistd.h */
#  endif
#  ifdef AZTEC_C
#    include <fcntl.h>
#    include "amiga/z-stat.h"
#    define RMDIR
#  endif
#endif /* AMIGA */

#if defined(VM_CMS) || defined(MVS)
#  include "tables.h"
#endif

#ifdef RISCOS
#  include "acorn/riscos.h"
#  define NO_SYMLINK
#endif

#if !defined(VMS) && !defined(MACOS) && !defined(AMIGA) && !defined(ATARI_ST)
#if !defined(VM_CMS) && !defined(MVS) && !defined(RISCOS)
#  include <sys/types.h>
#  include <sys/stat.h>
#endif
#endif

/* Some systems define S_IFLNK but do not support symbolic links */
#if defined (S_IFLNK) && defined(NO_SYMLINK)
#  undef S_IFLNK
#endif


/* For Pyramid */
#ifdef pyr
#  ifndef SYSV
#    define strrchr rindex
#  endif
#  define ZMEM
#endif /* pyr */


/* File operations--use "b" for binary if allowed or fixed length 512 on VMS */
#ifdef VMS
#  define FOPR  "r","ctx=stm","mbc=60"
#  define FOPM  "r+","ctx=stm","rfm=fix","mrs=512","mbc=60"
#  define FOPW  "w","ctx=stm","rfm=fix","mrs=512","mbc=60"
#else /* !VMS */
#  if defined(MODERN)
#    define FOPR "rb"
#    define FOPM "r+b"
#    ifdef TOPS20 /* TOPS20 MODERN? You kidding? */
#      define FOPW "w8"
#    else
#      define FOPW "wb"
#    endif
#  else /* !MODERN */
#    ifdef AMIGA
#      define FOPR "rb"
#      define FOPM "rb+"
#      define FOPW "wb"
#    else /* !AMIGA */
#      if defined(VM_CMS) || defined(MVS)
#         define FOPR "rb,recfm=fb"
#         define FOPM "r+"
#         define FOPW "wb,recfm=fb"
#         define FOPWT "w"
#      else /* VM_CMS || MVS */
#         define FOPR "r"
#         define FOPM "r+"
#         define FOPW "w"
#      endif /* VM_CMS || MVS */
#    endif /* ?AMIGA */
#  endif /* ?MODERN */
#endif /* VMS */

/* Open the old zip file in exclusive mode if possible (to avoid adding
 * zip file to itself).
 */
#ifdef OS2
#  define FOPR_EX FOPM
#else
#  define FOPR_EX FOPR
#endif


/* MDOS file attribute for directories */
#define MSDOS_DIR_ATTR 0x10


/* Define this symbol if your target allows access to unaligned data.
 * This is not mandatory, just a speed optimization. The compressed
 * output is strictly identical.
 */
#if (defined(MSDOS) && !defined(WIN32)) || defined(i386)
#    define UNALIGNED_OK
#endif
#if defined(mc68020) || defined(vax)
#    define UNALIGNED_OK
#endif

/* Enable use of optimized x86 assembler version of longest_match() for
   MSDOS and OS2 per default.  */
#if !defined(ATARI_ST) && (defined(MSDOS) || defined(OS2))
# if !defined(NO_ASM) && !defined(ASMV)
#  define ASMV
# endif
#endif /* !ATARI_ST && (MSDOS || OS2) */

/* Under MSDOS we may run out of memory when processing a large number
 * of files. Compile with MEDIUM_MEM to reduce the memory requirements or
 * with SMALL_MEM to use as little memory as possible.
 */
#ifdef SMALL_MEM
#   define CBSZ 2048 /* buffer size for copying files */
#   define ZBSZ 2048 /* buffer size for temporary zip file */
#else
# ifdef MEDIUM_MEM
#   define CBSZ 8192
#   define ZBSZ 8192
# else
#  ifdef OS2
#   ifdef __32BIT__
#     define CBSZ 0x40000
#     define ZBSZ 0x40000
#   else
#     define CBSZ 0xE000
#     define ZBSZ 0x7F00 /* Some libraries do not allow a buffer size > 32K */
#   endif
#  else
#   ifdef TOPS20
#    define CBSZ 524288
#    define ZBSZ 524288
#   else /* !TOPS20 */
#    if defined(VM_CMS) || defined(MVS)
#       define CBSZ 0x40000
#       define ZBSZ 0x40000
#    else /* !(VM_CMS || MVS) */
#       define CBSZ 16384
#       define ZBSZ 16384
#    endif /* ?(VM_CMS || MVS) */
#   endif /* ?TOPS20 */
#  endif
# endif
#endif

#if (defined(BIG_MEM) || defined(MMAP)) && !defined(DYN_ALLOC)
#   define DYN_ALLOC
#endif

#ifdef __human68k__
#  include <sys/xglob.h>
#  define MSVMS
#  define SSTAT h68_stat
  int h68_stat OF((char *, struct stat *));
#  define OS_CODE  0x300  /* pretend it's Unix */
#endif

#ifdef ATARI_ST
#  define MSDOS  /* what? should be fixed */
#  define MSVMS
#  ifndef O_BINARY
#    define O_BINARY 0
#  endif
#  ifndef S_IFMT
#    define S_IFMT        (S_IFCHR|S_IFREG|S_IFDIR)
#  endif

/* a whole bunch of functions needs Tos '\\' filenames
 * instead of '/',  the translation functions are in fileio.c:
 */
#  define unlink    st_unlink
#  define chmod     st_chmod
#  define mktemp    st_mktemp
#  define fopen     st_fopen
#  define open      st_open
#  define SSTAT     st_stat
#  define findfirst st_findfirst
#  define link      st_rename
#  define rmdir     st_rmdir

  int st_unlink    OF((char *));
  int st_chmod     OF((char *, int));
  char *st_mktemp  OF((char *));
  FILE *st_fopen   OF((char *, char *));
  int st_open      OF((char *, int));
  int st_stat      OF((char *, struct stat *));
  int st_findfirst OF((char *, struct ffblk *, int));
  int st_rename    OF((char *, char *));
  int st_rmdir     OF((char *));
#endif  /* ATARI */

#ifndef SSTAT
#  define SSTAT      stat
#endif
#ifdef S_IFLNK
#  define LSTAT      lstat
#else
#  define LSTAT      SSTAT
#endif


/* The following OS codes are defined in pkzip appnote.txt */
#ifdef AMIGA
#  define OS_CODE  0x100
#endif
#ifdef VMS
#  define OS_CODE  0x200
#endif
/* unix    3 */
#if defined(VM_CMS) || defined(MVS)
#  define OS_CODE  0x400
#endif /* VM_CMS || MVS */
/* vm/cms 4 */
#ifdef ATARI_ST
#  define OS_CODE  0x500
#endif
#ifdef OS2
#  define OS_CODE  0x600
#endif
#ifdef MACOS
#  define OS_CODE  0x700
#endif
/* z system 8 */
/* cp/m     9 */
#ifdef TOPS20
#  define OS_CODE  0xa00
#endif
#ifdef WIN32
#  define OS_CODE  0xb00
#endif
/* QDOS 12 */
#ifdef RISCOS
#  define OS_CODE  0xd00
#endif

#define NUM_HOSTS 14
/* Number of operating systems. Should be updated when new ports are made */

#if defined(MSDOS) && !defined(OS_CODE)
#  define OS_CODE  0x000
#endif
#ifndef OS_CODE
#  define OS_CODE  0x300  /* assume Unix */
#  ifndef UNIX
#    define UNIX
#  endif
#endif

/* can't use "return 0" from main() on VMS */
#ifndef EXIT
#  define EXIT  exit
#endif
#ifndef RETURN
#  define RETURN return
#endif

/* end of tailor.h */
